local Tunnel = module("vrp", "lib/Tunnel")
local Proxy = module("vrp", "lib/Proxy")
vRP = Proxy.getInterface("vRP")
vRPclient = Tunnel.getInterface("vRP","s4-house")
vRPCHouse = Tunnel.getInterface("s4-house","s4-house")
vRPSHouse = {}
Tunnel.bindInterface("s4-house",vRPSHouse)
Proxy.addInterface("s4-house",vRPSHouse)

CacheHouses = {}
AddEventHandler("onResourceStart", function(rs)
   if rs == "s4-house"  then
      local n = 0
      for k,v in pairs(Config.Houses) do
         local shopdata = exports.oxmysql:executeSync("SELECT * FROM `s4-house` WHERE id = '"..k.."' ")
         if #shopdata == 0 then 
            exports.oxmysql:execute("INSERT INTO `s4-house` (id, owner, name, garage, friends, extends) VALUES ('"..k.."', '"..Config.Houses_Template.owner.."', '"..Config.Houses_Template.name.."', '"..json.encode(Config.Houses_Template.garage).."', '"..json.encode(Config.Houses_Template.friends).."', '"..json.encode(Config.Houses_Template.extends).."')", {  })
            n = n+1
         end
         Wait(100)
      end
      LoadHouses()
      if n > 0 then
      print("S4-HOUSE: New "..n.." houses created from your config")
      else
         print("S4-HOUSE: No others houses to create")
      end
   end
end)


AddEventHandler("vRP:playerSpawn",function(user_id,source,first_spawn)
   if first_spawn then
   vRPCHouse.setCLHouseOwner(source,{user_id})
   end
end)

function vRPSHouse.getMoneyNow()
   local user_id = vRP.getUserId({source})
   local player = vRP.getUserSource({user_id})
   if user_id then
      local cashMoney = vRP.getMoney({user_id})
      local bankMoney = vRP.getBankMoney({user_id})
      vRPCHouse.setHouseCLMoney(player,{cashMoney,bankMoney})
   end
end

function vRPSHouse.openHouseChest(id)
   local user_id = vRP.getUserId({source})
   local player = vRP.getUserSource({user_id})
   vRP.openChest({player, "chest:house"..id, 500, nil, nil, nil})
end


function vRPSHouse.spawnHouseVehicle(veh,x,y,z,h)
   local user_id = vRP.getUserId({source})
   local player = vRP.getUserSource({user_id})
   if user_id then
     local veh_i = exports.oxmysql:executeSync("SELECT vehicle_plate,veh_type, engineDamage,fuel FROM vrp_user_vehicles WHERE user_id = @user_id AND vehicle = @veh ",{["@user_id"] = user_id,["@veh"] = veh})
     if veh_i then
         vRPclient.spawnHouseVehicle(player,{veh_i[1].veh_type,veh,veh_i[1].vehicle_plate,veh_i[1].engineDamage,veh_i[1].fuel,x,y,z,h})
     end
   end
end
LoadHouses = function() 

    local houses = exports.oxmysql:executeSync("SELECT * FROM `s4-house`")

    for k,v in pairs(houses) do

      local i = {
        name = v.name,
        price = Config.Houses[k].price,
        coords = {      
          house_in = Config.Houses[k].coords.house_in,
          house_out = Config.Houses[k].coords.house_out,
          garage_in = Config.Houses[k].coords.garage_in,
          garage_out = Config.Houses[k].coords.garage_out,
          stash = Config.Houses[k].coords.stash,
        },
        owner = v.owner,
        friends = json.decode(v.friends),
        garage =  json.decode(v.garage),
        garage_stock = Config.Houses[k].garage_stock,
        theme = v.theme,
        extends = json.decode(v.extends),
      }

      table.insert(CacheHouses, i)

    end

end

RegisterCommand("house_reload", function(source, args, rawCommand)
   CacheHouses = {}
   LoadHouses()
   TriggerClientEvent('s4-house:client:updateHouses', -1, CacheHouses)
   local user_id = vRP.getUserId({source})
   vRPCHouse.setCLHouseOwner(source,{user_id})
end)

function ReloadHousesAndSetOwners()
   CacheHouses = {}
   LoadHouses()
   TriggerClientEvent('s4-house:client:updateHouses', -1, CacheHouses)

   for _, playerId in ipairs(GetPlayers()) do
     local user_id = vRP.getUserId({playerId})
     vRPCHouse.setCLHouseOwner(playerId, {user_id})
   end
 end
 Citizen.CreateThread(function()
   while true do
     ReloadHousesAndSetOwners()
     Citizen.Wait(60000) 
   end
 end)
 
 

 

RegisterServerEvent("s4-house:server:tryBuy")
AddEventHandler("s4-house:server:tryBuy", function(data)
   local user_id = vRP.getUserId({source})
   local player = vRP.getUserSource({user_id})
      local house = GetHouseFromId(tonumber(data.id))
      if user_id and house then 
         if data.type == "cash" and vRP.getMoney({user_id}) >= house.price then 
            if vRP.tryPayment({user_id,house.price}) then
               BuyHouse(user_id, tonumber(data.id), player)
            else
               vRPclient.notify(player,{"Nu ai destui bani cash"})
            end
         end
         if data.type == "bank" and vRP.getBankMoney({user_id}) >= house.price  then
           if vRP.tryBankPayment({user_id,house.price}) then
               BuyHouse(user_id, tonumber(data.id), player)
            else
               vRPclient.notify(player,{"Nu ai destui bani in banca"})
            end
         end
      end
end)


function vRPSHouse.GetHousePlayers()
   local Players = {}
   for _, playerId in ipairs(GetPlayers()) do
      local user_id = vRP.getUserId({playerId})
      local name = GetPlayerName(playerId)
      Players[#Players+1] = { id = user_id,  name = name }
   end
   return Players
end

RegisterNetEvent("s4-house:server:AddFriends")
AddEventHandler("s4-house:server:AddFriends",function(id, pid, name)
   for k,v in pairs(CacheHouses[id].friends) do
      if v.id == pid then 
        return
      end   
   end
   table.insert(CacheHouses[id].friends, { id = pid,  name = name })
   TriggerClientEvent('s4-house:client:updateHouses', source, CacheHouses)

   exports.oxmysql:execute("UPDATE `s4-house` SET friends = '"..json.encode(CacheHouses[id].friends).."' WHERE id = '"..id.."'  ")
end)

RegisterNetEvent("s4-house:server:RemoveFriends")
AddEventHandler("s4-house:server:RemoveFriends",function(id, pid, name)
   for k,v in pairs(CacheHouses[id].friends) do
      if v.id == pid then 
         table.remove(CacheHouses[id].friends, k) 
         break
      end   
   end
   TriggerClientEvent('s4-house:client:updateHouses', source, CacheHouses)
   exports.oxmysql:execute("UPDATE `s4-house` SET friends = '"..json.encode(CacheHouses[id].friends).."' WHERE id = '"..id.."'  ")
end)

RegisterNetEvent("s4-house:server:StreamFriends")
AddEventHandler("s4-house:server:StreamFriends",function()
   TriggerClientEvent('s4-house:client:updateHouses', -1, CacheHouses) 
end)

function vRPSHouse.tryHouseSell(data)
   local user_id = vRP.getUserId({source})
   local player = vRP.getUserSource({user_id})
   local house = GetHouseFromId(tonumber(data.id))
   house.id = tonumber(data.id)
   if user_id and house then 
      if data.type == "cash" then 
         result = SellHouse(user_id, house)
         if result ~= false then 
            vRP.giveMoney({user_id,tonumber(result)})
         end
      end
      if data.type == "bank" then
         result = SellHouse(user_id, house)
         if result ~= false then 
            vRP.giveBankMoney({user_id,tonumber(result)})
         end
      end
      
   end
end




BuyHouse = function(u_id, id, src) 
   for k,v in pairs(CacheHouses) do
      if k == id then
         CacheHouses[k].owner = u_id
         exports.oxmysql:execute('UPDATE `s4-house` SET owner = @idf WHERE id = @id', { ['@id'] = id,   ['@idf'] = u_id })
		 TriggerClientEvent('s4-house:client:updateHouses', src, CacheHouses, id)
       TriggerEvent("s4-house:server:SetName",id,"House Bought")
         -- TriggerClientEvent('s4-house:client:updateHouses', -1, CacheHouses, nil, true)
         return
      end
   end
end
SellHouse = function(user_id, house) 
   local player = vRP.getUserSource({user_id})
   for k,v in pairs(CacheHouses) do
      if k == house.id then
         if tonumber(CacheHouses[k].owner) == user_id then 
            print(CacheHouses[k].owner,user_id)
         CacheHouses[k].owner = 0
		   CacheHouses[k].garage = Config.Houses_Template.garage
		   CacheHouses[k].friends = Config.Houses_Template.friends
		   CacheHouses[k].extends = Config.Houses_Template.extends
           exports.oxmysql:execute('UPDATE `s4-house` SET owner = @idf, garage = @garage, friends = @friends, extends = @extends WHERE id = @id', {
 		         ['@id'] = house.id,
				  ['@idf'] = 0,
				  ['@garage'] = json.encode(Config.Houses_Template.garage),
				  ['@friends'] = json.encode(Config.Houses_Template.friends),
				  ['@extends'] = json.encode(Config.Houses_Template.extends)
		   })
		   TriggerClientEvent('s4-house:client:updateHouses', player, CacheHouses, house.id)
           TriggerClientEvent('s4-house:client:updateHouses', -1, CacheHouses, house.id, true)
           return (house.price/100)*75
         end
      end
   end
   return false 
end



 


RegisterNetEvent('s4-house:server:request')
AddEventHandler('s4-house:server:request', function()
   local source = source
   if #CacheHouses == 0 then 
      TriggerClientEvent('s4-house:client:tryAgain', tonumber(source))
   else 
      TriggerClientEvent('s4-house:client:updateHouses', tonumber(source), CacheHouses)
   end
   
end)

RegisterNetEvent("s4-house:server:setbucket")
AddEventHandler("s4-house:server:setbucket",function(id)
   if not CacheHouses[id].bucket_id then 
      CacheHouses[id].bucket_id = id + 4000
   end
   SetPlayerRoutingBucket(source, CacheHouses[id].bucket_id)
end)

RegisterNetEvent("s4-house:server:outbucket")
AddEventHandler("s4-house:server:outbucket",function()
   SetPlayerRoutingBucket(source, 0)
end)


RegisterNetEvent("s4-house:server:setTheme")
AddEventHandler("s4-house:server:setTheme",function(id, theme)
   local user_id = vRP.getUserId({source})
   local player = vRP.getUserSource({user_id})
   if CheckAuth(id, user_id) == true then 
      CacheHouses[id].theme = theme
      TriggerClientEvent('s4-house:client:updateHouses', -1, CacheHouses, id, true)
      exports.oxmysql:execute("UPDATE `s4-house` SET theme = '"..theme.."' WHERE id = '"..id.."'  ")
   end
end)

RegisterNetEvent("s4-house:server:setExtends")
AddEventHandler("s4-house:server:setExtends",function(id, data)
   local user_id = vRP.getUserId({source})
   local player = vRP.getUserSource({user_id})
   if CheckAuth(id, user_id) == true then 
      table.insert(CacheHouses[id].extends, data)
      TriggerClientEvent('s4-house:client:updateHouses', -1, CacheHouses, id, true)
      exports.oxmysql:execute("UPDATE `s4-house` SET extends = '"..json.encode(CacheHouses[id].extends).."' WHERE id = '"..id.."'  ")
   end
end)






RegisterNetEvent("s4-house:server:SetName")
AddEventHandler("s4-house:server:SetName",function(id, name)
   local user_id = vRP.getUserId({source})
   local player = vRP.getUserSource({user_id})
   if CheckAuth(id, user_id) == true then 
      CacheHouses[id].name = name
      TriggerClientEvent('s4-house:client:updateHouses', -1, CacheHouses, id, true)
      exports.oxmysql:execute("UPDATE `s4-house` SET name = '"..name.."' WHERE id = '"..id.."'  ")
   end
end)


RegisterNetEvent("s4-house:server:outgarage")
AddEventHandler("s4-house:server:outgarage",function(id, garage,model)
   CacheHouses[id].garage = garage
   TriggerClientEvent('s4-house:client:updateHouses', -1, CacheHouses)
   exports.oxmysql:execute("UPDATE `s4-house` SET garage = '"..json.encode(CacheHouses[id].garage).."' WHERE id = '"..id.."'  ")
   exports.oxmysql:execute("UPDATE vrp_user_vehicles SET houseGarage = @bool WHERE vehicle = '"..model.."'",{["@bool"] = true})
end)


RegisterNetEvent("s4-house:server:addGarageSlot")
AddEventHandler("s4-house:server:addGarageSlot",function(id, slot, props, plate, model)
   print("IN")
   print(model)
   local user_id = vRP.getUserId({source})
   local player = vRP.getUserSource({user_id})
   if GetGarageAvailable(id) == 0 then return end
   CacheHouses[id].garage[slot] = { id = slot, propss = props, plate = plate, model = model }
   TriggerClientEvent('s4-house:client:updateHouses', player, CacheHouses)
   TriggerClientEvent('s4-house:client:updateHouses', -1, CacheHouses)
   exports.oxmysql:execute("UPDATE `s4-house` SET garage = '"..json.encode(CacheHouses[id].garage).."' WHERE id = '"..id.."'  ")
   exports.oxmysql:execute("UPDATE vrp_user_vehicles SET houseGarage = @bool WHERE vehicle = '"..model.."'",{["@bool"] = true})
   TriggerClientEvent('s4-house:client:switch', player, id, "ginv_d")
end)

CheckAuth = function(id, idf)
   house = GetHouseFromId(tonumber(id))
   auth = false
   if house.owner == idf then 
      auth = true
   end
   for i,val in pairs(house.friends) do
      if val.id == idf then  
         auth = true
      end
   end
   return auth
end
GetHouseFromId = function(id)
   for k,v in pairs(CacheHouses) do
      if k == id then 
         return v
      end
   end
end

GetGarageAvailable = function(id) 
   house = GetHouseFromId(tonumber(id))
   
   for i=1, house.garage_stock  do
     if type(house.garage[i]) == "nil" then 
        return i
     end
   end

   return 0
end